<section class="section pt-5 pb-0 mb-0">
  <div class="px-6">
    <nav class="breadcrumb" aria-label="breadcrumbs">
      <ul>
        <li><a href="/app">Home</a></li>
        <li>
          <a href="/app/challenge/{{challenge.id}}">
            {{challenge.name}}
          </a>
        </li>
        <li class="is-active">
          <a
            href="/app/challenge/{{challenge.id}}/details"
            aria-current="page"
          >Details</a>
        </li>
      </ul>
    </nav>
    <h4 class="title is-size-4">
      Challenge Details
    </h4>
    <div class="box px-0">
      <div class="px-5 mb-4">
        <div
          class="columns is-vcentered is-multiline is-justify-content-space-between"
        >
          <div class="column">
            <h5 class="title is-size-4">Challenge Leaderboard</h5>
            <p class="subtitle is-size-6">All users for this challenge</p>
          </div>
          <div class="column has-text-right is-flex">
            <div class="field has-addons ml-auto mb-0-tablet mr-3">
              <div class="control has-icons-right">
                <span class="icon is-right">
                  <ion-icon name="search-outline"></ion-icon>
                </span>
                <input class="input" type="text" placeholder="Type to search..." onkeyup="filter(this)" />
              </div>
            </div>
            <button
              class="button is-primary is-inline-flex is-align-items-center"
                id="btnUpdateScores"
            >
              <span class="has-text-white">
                Update Scoring
              </span>
            </button>
          </div>
        </div>
      </div>
      <div class="table-container mb-0">
        <table class="table is-striped is-fullwidth is-size-7 mb-0">
          <thead>
            <tr>
              <th class="px-5 py-3 has-text-grey">
                Entrant
              </th>
              {{#each levels}}
              <th class="px-5 py-3 has-text-grey">
                Level {{level}} <br/>
                <span class="has-text-greyer has-text-weight-medium" title="ID #{{id}}">
                  {{title}}
                </span>
              </th>
              {{/each}}
              <th></th>
            </tr>
          </thead>
          <tbody id="listOfEntrants">
            {{#each userLevelDetails}}
              <tr id="user-row-{{user_id}}">
                <td class="px-5 py-4">
                  <div class="is-flex is-align-items-center">
                    <div class="is-flex is-align-items-center">
                      <img
                        class="mr-3 image is-32x32 is-rounded is-cover"
                        style="border-radius: 50% !important;"
                        src="{{picture}}"
                        alt="alt"
                      /><div>
                        <p class="is-size-6 has-text-weight-medium is-users-name" title="{{user_id}}" id="txtName">{{name}}</p>
                        <span class="has-text-grey" id="txtGitlabHandle">@{{gitlab_handle}}</span>
                      </div>
                    </div>
                  </div>
                  <div class="is-edit">
                    <br/>
                    {{#if (isEqual role "entrant")}}
                      <button
                        class="button is-info is-light ml-2" 
                        data-rowid="user-row-{{user_id}}"
                        id="btnPromoteUser-{{user_id}}"
                        onclick="promoteUser({{challenge_id}}, {{user_id}})"
                      >
                        🔼 Make admin
                      </button>
                    {{else if (isEqual role "owner")}}
                      <span class="icon">
                        <ion-icon name="lock-closed-outline" size="large"></ion-icon>
                      </span>
                      <span>
                        Owner
                      </span>
                    {{else if (isEqual role "admin")}}
                      <span class="icon">
                        <ion-icon name="cog-outline" size="large"></ion-icon>
                      </span>
                      <span>
                        Admin
                      </span>
                    {{/if}}
                    </div>
                </td>
                {{#each levels}}
                <td class="px-5 py-4">
                  {{#if completed}}
                    <span class="icon has-text-success mr-1">
                      <ion-icon name="checkbox-outline"></ion-icon>
                    </span>
                    <a class="tag is-primary is-light" href="{{ref}}" target="_blank">
                      Completed 
                    </a>
                    <a 
                      class="tag is-delete is-danger is-edit is-delete-start" 
                      data-rowid="user-row-{{user_id}}"
                      data-levelid="{{level_id}}" 
                      data-challengeid="{{challenge_id}}"
                      data-userid="{{user_id}}"
                    ></a>
                    <button 
                      id="btnDeleteCompleted-{{level_id}}-{{challenge_id}}-{{user_id}}" 
                      class="button is-danger is-small is-delete-confirm is-hidden" 
                      data-rowid="user-row-{{user_id}}" 
                      data-levelid="{{level_id}}" 
                      data-challengeid="{{challenge_id}}"
                      data-userid="{{user_id}}"
                      onclick="confirmDeleteCompleted({{level_id}}, {{challenge_id}}, {{user_id}})"
                    >
                      Confirm
                    </button>
                  {{else}}
                    <span class="icon mr-1">
                      <ion-icon name="square-outline"></ion-icon>
                    </span>
                    <span class="tag is-warning is-light">
                      Incomplete 
                    </span>
                    <a 
                      class="tag button is-success is-edit is-add-button" 
                      style="text-decoration: none;"
                      data-rowid="user-row-{{user_id}}"
                      data-levelid="{{level_id}}" 
                      data-challengeid="{{challenge_id}}"
                      data-userid="{{user_id}}"
                    >
                      ☑️
                    </a>
                    <div id="add-{{level_id}}-{{challenge_id}}-{{user_id}}" class="is-adding-complete is-hidden">
                      <br/>
                      <div class="field has-addons">
                        <div class="control">
                          <input 
                            id="txtAddRef-{{level_id}}-{{challenge_id}}-{{user_id}}"
                            class="input" 
                            type="text" 
                            placeholder="Link (if applicable)">
                        </div>
                        <div class="control">
                          <button 
                            class="button is-info" 
                            id="btnAdd-{{level_id}}-{{challenge_id}}-{{user_id}}"
                            onclick="confirmAddCompleted({{level_id}}, {{challenge_id}}, {{user_id}})">
                            Add
                          </button>
                        </div>
                      </div>
                    </div>
                  {{/if}}
                </td> 
                {{/each}}
                <td class="px-5 py-4">
                  <div class="field is-grouped">
                    <div class="control">
                      <button 
                        id="btnDeleteUser-{{user_id}}"
                        class="button is-danger is-small is-delete-user-confirm is-hidden" 
                        data-rowid="user-row-{{user_id}}"
                        data-userid="{{user_id}}"
                        onclick="confirmDeleteUser({{challenge_id}}, {{user_id}})"
                      >
                        Remove this user?
                      </button>
                    </div>
                    <div class="control">
                      <button 
                        class="button is-danger is-delete-button is-edit" 
                        data-rowid="user-row-{{user_id}}"
                        data-userid="{{user_id}}"
                      >
                        <span class="icon">
                          <ion-icon name="trash-outline"></ion-icon>
                        </span>
                      </button>
                    </div>
                    <div class="control">
                      <button class="button is-link is-light is-edit-button" data-rowid="user-row-{{user_id}}">
                        <span class="icon">
                          <ion-icon name="create-outline"></ion-icon>
                        </span>
                      </button>
                    </div>
                  </div>
                </td>
              </tr>
            {{/each}}
          </tbody>
        </table>
      </div>
      <div
        class="pt-4 has-text-centered"
        style="border-top: 1px solid #E1E4E8;"
      >
        <a
          class="button is-ghost has-text-primary mx-auto is-inline-flex is-align-items-center"
          href="/leaderboard/{{challenge.id}}"
          target="_blank"
        >
          <span class="icon is-large">
            <ion-icon name="stats-chart-outline" size="large"></ion-icon>
          </span>
          <span>
            Open Leaderboard
          </span>
        </a>
      </div>
    </div>
  </div>
</section>

{{#section 'script'}}
<script>
  const btnUpdateScores = $("#btnUpdateScores");
  const challengeId = location.pathname.split("/")[3];
  const baseUrl = `${location.protocol}//${location.host}`

  btnUpdateScores.click((e) => {
      btnUpdateScores.addClass("is-loading");
      $.get(`${baseUrl}/api/v1/public/update/challenge/${challengeId}`, (v) => {
          console.log(v);
      })
      .done(() => { setTimeout(() => location.reload(), 2500) } )
      .always(() => { setTimeout(() => btnUpdateScores.removeClass('is-loading'), 3500) });
  })

  $('.is-edit-button').each(function () {
    var $this = $(this);
    $this.on("click", function () {
      $('.is-editing').each(function () {
        $(this).removeClass('is-editing')
      });
      $(`#${$(this).data('rowid')}`).addClass('is-editing');
    })
  });

  $('.is-delete-start').each(function () {
    var $this = $(this);
    $this.on("click", function () {
      const level_id = $this.data('levelid');
      const challenge_id = $this.data('challengeid');
      const user_id = $this.data('userid');
      var delBtn = $(`#btnDeleteCompleted-${level_id}-${challenge_id}-${user_id}`)
      delBtn.removeClass('is-hidden');
      console.log("Level", level_id, "Challenge", challenge_id, "User", user_id);
    })
  });

  function filter(elm) {
    const value = $(elm).val().toLowerCase();
    $("#listOfEntrants > tr").each(function() {
      if ($(this).find("#txtName").text().toLowerCase().search(value) > -1) {
        $(this).show();
      } else {
        if ($(this).find("#txtGitlabHandle").text().toLowerCase().search(value) > -1) {
          $(this).show();
        } else {
          $(this).hide();
        }
      }
    })
  }

  function confirmDeleteCompleted(level_id, challenge_id, user_id) {
    const delBtn = $(`#btnDeleteCompleted-${level_id}-${challenge_id}-${user_id}`)
    delBtn.addClass('is-loading');
    console.log("Level", level_id, "Challenge", challenge_id, "User", user_id);
    $.ajax({
      url: `/app/challenge/${challenge_id}/completed?levelId=${level_id}&userId=${user_id}`,
      method: 'DELETE'
    }).done((v) => location.reload())
  }

  $('.is-delete-button').each(function () {
    var $this = $(this);
    $this.on("click", function () {
      const user_id = $this.data('userid');
      var delBtn = $(`#btnDeleteUser-${user_id}`);
      delBtn.removeClass('is-hidden');
    });
  });

  function confirmDeleteUser(challenge_id, user_id) {
    console.log("Delete User", user_id);
    $.ajax({
      url: `/app/challenge/${challenge_id}/entrant/${user_id}`,
      method: 'DELETE'
    }).done((v) => location.reload())
  }

  $('.is-add-button').each(function () {
    var $this = $(this);
    $this.on("click", function () {
      const level_id = $this.data('levelid');
      const challenge_id = $this.data('challengeid');
      const user_id = $this.data('userid');
      var addDiv = $(`#add-${level_id}-${challenge_id}-${user_id}`)
      addDiv.removeClass('is-hidden');
    })
  });

  function confirmAddCompleted(level_id, challenge_id, user_id) {
    console.log("Level", level_id, "Challenge", challenge_id, "User", user_id);
    var btnAdd = $(`#btnAdd-${level_id}-${challenge_id}-${user_id}`);
    btnAdd.addClass('is-loading');
    var txtBox = $(`#txtAddRef-${level_id}-${challenge_id}-${user_id}`);
    
    $.ajax({
      url: `/app/challenge/${challenge_id}/completed?levelId=${level_id}&userId=${user_id}&ref=${encodeURI(txtBox.val())}`,
      method: 'PUT'
    }).done((v) => location.reload())
  }

  function promoteUser(challenge_id, user_id) {
    console.log("Challenge", challenge_id, "User", user_id);
    ///challenge/:challenge_id/promote/:user_id
    $.ajax({
      url: `/app/challenge/${challenge_id}/promote/${user_id}`,
      method: 'PUT'
    }).done((v) => location.reload())
  }
</script>
{{/section}}